package com.widgetcast
{
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.display.DisplayObject;
	import flash.net.URLLoader;
	import flash.net.URLRequest;

	/**
	* Main Widgetcast API to get file location 
	*/
	public class wctapi
	{
		private static var mainobject:Object;
		/**
		 * The absolute path of main swf
		 */
		public static var URLbase:String="";
		private static var xmlLoader:URLLoader;
		private static var xmlurl:String;
		private static var listenobject:Object;
		
		/**
		* Initial method.
		* 
		* <p>This is must be executed before call connect() or loadxml().</p>
		* 
		* 
		* @param param1 Main class object.
		* 
		* @example
		* <listing>
		* 
		* public class Main extends Sprite
		* {
		*     public function Main ()
		*     {
		*         super ();
		*         wctapi.init(this);
		*         this.addEventListener(wctapiEvent.COMPLETE,LoadComplete);
		*     }
		* }
		* 
		* </listing> 
		*/ 
		public static function init (display:DisplayObject):void
		{
			mainobject = display;
			
			//waiting for swf load complete,non use Event.Complete which has some problem in firefox
			mainobject.addEventListener(Event.ENTER_FRAME,enterFrameHandler);
		}
		
		/**
		* Finish loaded swf
		*/
		private static function enterFrameHandler (e:Event):void 
		{  
			var percent:Number = mainobject.root.loaderInfo.bytesLoaded / mainobject.root.loaderInfo.bytesTotal;  
			if (percent >= 1) 
			{  
				mainobject.removeEventListener (Event.ENTER_FRAME, enterFrameHandler);
				URLbase = trans(mainobject.loaderInfo.url);
				mainobject.dispatchEvent(new wctapiEvent(wctapiEvent.COMPLETE));
			}
		}  
		
		/**
		* Transforms file loaction to http format
		*/
		private static function trans (_string:String):String
		{
			var search_str:String="/";
			var _string:String=_string.split("\\").join("/");
			var endindex:Number=_string.lastIndexOf(search_str);
			var string:String=_string.substring(0,endindex+1);
			return string;
		}
		
		/**
		 * Removes the absolute path String
		 */ 
		public static function clear():void
		{
			URLbase = "";
		}
		
		/**
		 * Combines the absolute path String
		 * 
		 * @param param1 sourcefile path.
		 * 
		 * @example
		 * <listing>
		 * 
		 * private function loadpic ():void
		 * {
		 *     var loader:Loader = new Loader();
		 *     loader.load( new URLRequest(wctapi.connect("flower.jpg")) 
		 *     this.addChilde(loader);
		 * }
		 * 
		 * </listing> 
		 */
		 public static function connect(fileURL:String):String
		{
			return URLbase + fileURL;
		}
		

		/**
		* Loads xml file if needed
		*
		* <p></p>
		* 
		* @param param1 XML path.
		* @param param2 addEventListener target.
		* 
		* @example
		* <listing>
		* 
		* private function startLoadXML ():void
		* {
		*     wctapi.loadxml("piclist.xml",this);
		*     this.addEventListener (wctapiEvent.XMLLOADED,completeLoadXML);
		* }
		* 
		* private function completeLoadXML (e:wctapiEvent):void
		* {
		*     var xmlData:XML = new XML(e.data);
		* }
		* </listing> 
		*/
		public static function loadxml(fileURL:String,target:Object):void
		{
			listenobject = target;
			xmlurl = fileURL;
			//URLbase is the location of swf
			xmlLoader = new URLLoader (new URLRequest(connect(xmlurl)));
	
			xmlLoader.addEventListener (Event.COMPLETE, completeLoadXML);
			xmlLoader.addEventListener (IOErrorEvent.IO_ERROR , ioErrorHandler);
		}
		
		private static function ioErrorHandler (e:IOErrorEvent):void
		{
			URLbase = "";
			xmlLoader = new URLLoader(new URLRequest(xmlurl));
			xmlLoader.addEventListener (Event.COMPLETE, completeLoadXML);
		}

		private static function completeLoadXML(e:Event):void
		{
			var event:wctapiEvent = new wctapiEvent(wctapiEvent.XMLLOADED);
			event.data = e.target.data;
			listenobject.dispatchEvent(event);
		}
	}
}